=== debian/changelog ===
orthanc (0.7.6+dfsg-1) unstable; urgency=medium

  [ Sebastien Jodogne ]
  * New upstream version: 0.7.6
  * Removed explicit dependency on libboost-atomic1.54-dev. Closes: #751695

  [ Andreas Tille ]
  * fix debian/watch to correctly append +dfsg
  * get-orig-source: add -compression xz

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 12 Jun 2014 14:17:13 +0200

orthanc (0.7.5+dfsg-1) unstable; urgency=medium

  [ Sebastien Jodogne ]
  * New upstream version: 0.7.5

  [ Andreas Tille ]
  * Add doc-base control file

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 09 May 2014 13:25:07 +0200

orthanc (0.7.4+dfsg-1) unstable; urgency=medium

  * New upstream version: 0.7.4
  * Use libboost-atomic1.54-dev >= 1.54.0-5 explicitly, because of #739904

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 28 Apr 2014 12:37:39 +0200

orthanc (0.7.3+dfsg-1) unstable; urgency=low

  * New upstream version: 0.7.3
  * Minimal version for libgoogle-glog is 0.3.3. Closes: #736845
  * Replacement of minified JavaScript files by their sources. Closes: #737448
  * Change from Google Code to GitHub

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 18 Feb 2014 10:28:34 +0100
