=== debian/control ===
Source: orthanc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
Section: science
Priority: optional
Standards-Version: 3.9.5
Homepage: https://code.google.com/p/orthanc/
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9),
               initscripts (>= 2.88dsf-13.3),
               libboost-all-dev (>= 1.54.0-5),
               libcharls-dev,
               libcurl4-openssl-dev | libcurl4-dev,
               libdcmtk2-dev,
               libgoogle-glog-dev (>= 0.3.3),
               libgtest-dev (>= 1.6.0),
               libjsoncpp-dev,
               liblua5.1-0-dev (>= 5.1.0),
               libpng-dev,
               libsqlite3-dev,
               libssl-dev,
               libwrap0-dev,
               uuid-dev,
               zlib1g-dev,
	       doxygen,
               unzip,
	       libjs-jquery (>= 1.7.2),
	       yui-compressor
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/orthanc/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/orthanc/trunk/

Package: orthanc
Architecture: any
Depends: adduser, dcmtk, ${misc:Depends}, ${shlibs:Depends}
Description: RESTful DICOM server for healthcare and medical research
 Orthanc aims at providing a simple, yet powerful standalone DICOM
 server. Orthanc can turn any computer running Windows or Linux into a
 DICOM store (in other words, a mini-PACS system). Its architecture is
 lightweight, meaning that no complex database administration is
 required, nor the installation of third-party dependencies.
 .
 What makes Orthanc unique is the fact that it provides a RESTful
 API. Thanks to this major feature, it is possible to drive Orthanc
 from any computer language. The DICOM tags of the stored medical
 images can be downloaded in the JSON file format. Furthermore,
 standard PNG images can be generated on-the-fly from the DICOM
 instances by Orthanc.
 .
 Orthanc lets its users focus on the content of the DICOM files,
 hiding the complexity of the DICOM format and of the DICOM protocol.

Package: liborthancclient0.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Orthanc Client runtime library
 Orthanc Client is a library to access the content of a remote
 instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
 for healthcare and medical research.
 .
 This package includes the client library.

Package: liborthancclient-dev
Architecture: any
Section: libdevel
Depends: liborthancclient0.7 (= ${binary:Version}), ${misc:Depends}
Description: Orthanc Client development files
 Orthanc Client is a library to access the content of a remote
 instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
 for healthcare and medical research.
 .
 This package includes the header files for C++ code.

Package: liborthancclient-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Orthanc Client documentation
 Orthanc Client is a library to access the content of a remote
 instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
 for healthcare and medical research.
 .
 This package includes the documentation and the sample codes.
