## orthanc 0.8.4+dfsg

=== debian/changelog ===
orthanc (0.8.4+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version

  [ Sebastien Jodogne ]
  * Fixes
  * Standards-Version: 3.9.6

 -- Andreas Tille <tille@debian.org>  Mon, 13 Oct 2014 11:50:53 +0200

orthanc (0.8.3+dfsg-1) unstable; urgency=medium

  * New upstream version: 0.8.3
    Closes: #761640
  * Upgrade Mongoose version: 3.1 to 3.8
  * Packaging of the plugin SDK

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 12 Sep 2014 11:30:53 +0200

orthanc (0.8.2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Add full text CC-BY
    Closes: #757676
  * d/control: Add new Build-Depends: libpugixml-dev

 -- Andreas Tille <tille@debian.org>  Wed, 20 Aug 2014 14:27:21 +0200

orthanc (0.8.0+dfsg-1) unstable; urgency=medium

  * New upstream version: 0.8.0

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 11 Jul 2014 11:27:56 +0200
