=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: orthanc
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
+Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
+           Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: https://code.google.com/p/orthanc/
 Build-Depends: cmake (>= 2.8),
                debhelper (>= 9),
@@ -16,6 +17,7 @@
                libgtest-dev (>= 1.6.0),
                libjsoncpp-dev,
                liblua5.1-0-dev (>= 5.1.0),
+               libpugixml-dev,
                libpng-dev,
                libsqlite3-dev,
                libssl-dev,
@@ -49,7 +51,7 @@
  Orthanc lets its users focus on the content of the DICOM files,
  hiding the complexity of the DICOM format and of the DICOM protocol.
 
-Package: liborthancclient0.7
+Package: liborthancclient0.8
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -63,11 +65,12 @@
 Package: liborthancclient-dev
 Architecture: any
 Section: libdevel
-Depends: liborthancclient0.7 (= ${binary:Version}), ${misc:Depends}
+Depends: liborthancclient0.8 (= ${binary:Version}), ${misc:Depends}
 Description: Orthanc Client development files
  Orthanc Client is a library to access the content of a remote
- instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
- for healthcare and medical research.
+ instance of Orthanc. This package also contains the plugin SDK.
+ Orthanc is a lightweight, RESTful DICOM server for healthcare and
+ medical research.
  .
  This package includes the header files for C++ code.
 
@@ -77,7 +80,8 @@
 Depends: ${misc:Depends}
 Description: Orthanc Client documentation
  Orthanc Client is a library to access the content of a remote
- instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
- for healthcare and medical research.
+ instance of Orthanc. This package also contains the plugin SDK.
+ Orthanc is a lightweight, RESTful DICOM server for healthcare and
+ medical research.
  .
  This package includes the documentation and the sample codes.
