=== debian/watch ===
version=3
opts="uversionmangle=s/$/+dfsg/g" \
https://github.com/jodogne/Orthanc/releases .*/download/[\d.]+/Orthanc-(\d\S*)\.tar\.gz
